<?xml version='1.0'?>

<xsl:stylesheet 
xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" >           





<!-- This is version 0.5 of an IPTC NewsML stylesheet produced by David Allen, MD IPTC to implement pruning and grafting on the NewsML tree using the Update element. Copyright 2000 IPTC. It assumes the use of Update to amend the Revision level is deprecated-->
<!-- It has been tested with the xt parser from James Clark and the Saxon parser from  Michael Kay-->
<!-- It require the NewsMLv1.0.dtd -->


<xsl:output method="xml" version="1.0" encoding="utf-8" doctype-public="newsml:iptc.org:20001006:NewsMLv1.0" doctype-system="../DTD/NewsMLv1.0.dtd"/>

<xsl:variable name="root" select="/"/>

<xsl:template match="/">
<xsl:apply-templates select="//Update"/>
<xsl:if test="$root//NewsIdentifier/RevisionId/@Update='N'">
<xsl:message terminate="yes">
<xsl:text>This is not a valid Updating NewsItem.</xsl:text>
<xsl:text>Update action terminated.</xsl:text>
</xsl:message>
</xsl:if>
<xsl:if test="$root//NewsIdentifier/RevisionId/@Update='U'">
<xsl:message terminate="no">
<xsl:text>Updating NewsItem Content.</xsl:text>
</xsl:message>
<xsl:apply-templates select="Update"/>
</xsl:if>
<xsl:if test="$root//NewsIdentifier/RevisionId/@Update='A'">
<xsl:message terminate="no">
<xsl:text>Updating NewsItem status.</xsl:text>
</xsl:message>
<xsl:call-template name="Action"/>
</xsl:if>
</xsl:template>


<xsl:template match="Update">
<xsl:text disable-output-escaping="yes">&lt;?xml-stylesheet type="text/xsl" href="./IPTCNewsML3.xsl"?&gt;</xsl:text>
<xsl:for-each select="/NewsML/NewsItem">
<xsl:variable name="NIFile">
<xsl:call-template name="Catent">
<xsl:with-param name="NID" select="concat('urn:newsml:',.//ProviderId,':',.//DateId,':',.//NewsItemId,':',.//RevisionId/@PreviousRevision)"/>
</xsl:call-template>
</xsl:variable>
<xsl:for-each select="document($NIFile)">
<xsl:apply-templates mode="FCopy">
<xsl:with-param name="RevNo" select="$root//RevisionId"/>
</xsl:apply-templates>
</xsl:for-each>
</xsl:for-each>
</xsl:template>


<xsl:template name="Action">
<xsl:text disable-output-escaping="yes">&lt;?xml-stylesheet type="text/xsl" href="../stylesheets/IPTCNewsML3.xsl"?&gt;</xsl:text>
<xsl:variable name="NIFile">
<xsl:call-template name="Catent">
<xsl:with-param name="NID" select="concat('urn:newsml:',.//ProviderId,':',.//DateId,':',.//NewsItemId,':',.//RevisionId)"/>
</xsl:call-template>
</xsl:variable>
<xsl:apply-templates mode="F2Copy">
<xsl:with-param name="RevNo" select=".//RevisionId"/>
<xsl:with-param name="PRevNo" select=".//RevisionId/@PreviousRevision"/>
<xsl:with-param name="bodyref" select="/NewsML/NewsItem/NewsComponent/@Duid"/>
<xsl:with-param name="original" select="$NIFile"/>
</xsl:apply-templates> 
</xsl:template>


<xsl:template match="*|@*" mode="F2Copy">
<xsl:param name="RevNo"/>
<xsl:param name="PRevNo"/>
<xsl:param name="bodyref"/>
<xsl:param name="original"/>
<xsl:variable name="holdrev" select="$RevNo"/>
<xsl:variable name="holdbod" select="$bodyref"/>
<xsl:variable name="holdorig" select="$original"/>
<xsl:variable name="locrev" select="$PRevNo"/>
<xsl:choose>
<xsl:when test="RevisionId">
<xsl:for-each select="/NewsML/NewsItem/Identification/NewsIdentifier">
<xsl:copy>
<xsl:copy-of select="@*"/>
<xsl:for-each select="/NewsML/NewsItem/Identification/NewsIdentifier/ProviderId">
<xsl:copy-of select="."/>
</xsl:for-each>
<xsl:for-each select="/NewsML/NewsItem/Identification/NewsIdentifier/DateId">
<xsl:copy-of select="."/>
</xsl:for-each>
<xsl:for-each select="/NewsML/NewsItem/Identification/NewsIdentifier/NewsItemId">
<xsl:copy-of select="."/>
</xsl:for-each>
<xsl:element name="RevisionId" namespace="">
<xsl:attribute name="PreviousRevision"><xsl:value-of select="$PRevNo"/></xsl:attribute>
<xsl:attribute name="Update">N</xsl:attribute>
<xsl:value-of select="$RevNo"/>
</xsl:element>
<xsl:for-each select="/NewsML/NewsItem/Identification/NewsIdentifier/PublicIdentifier">
<xsl:copy-of select="."/>
</xsl:for-each>
</xsl:copy>
</xsl:for-each>
</xsl:when>
<xsl:otherwise>
<xsl:variable name="upact">
<xsl:if test="@Duid=$bodyref">
<xsl:text>Replace</xsl:text>
</xsl:if>
<xsl:if test="not(@Duid)"/>
</xsl:variable>
<xsl:variable name="upins">
<xsl:if test="$upact='Replace'">
<xsl:for-each select="document($original)">
<xsl:copy-of select="/NewsML/NewsItem/NewsComponent[@Duid=$bodyref]"/>
</xsl:for-each>
</xsl:if>
<xsl:if test="not($upact)"/>
</xsl:variable>
<xsl:choose>
<xsl:when test="$upact!='Replace'">
<xsl:copy>
<xsl:apply-templates select="@*" mode="F2Copy"/>
<xsl:apply-templates mode="F2Copy">
<xsl:with-param name="RevNo" select="$holdrev"/>
<xsl:with-param name="PRevNo" select="$locrev"/>
<xsl:with-param name="bodyref" select="$holdbod"/>
<xsl:with-param name="original" select="$holdorig"/>
</xsl:apply-templates>
</xsl:copy>
</xsl:when>
<xsl:otherwise>
<xsl:copy-of select="$upins"/>
</xsl:otherwise>
</xsl:choose>
</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template match="*|@*" mode="FCopy">
<xsl:param name="RevNo"/>
<xsl:variable name="locrev" select="$RevNo"/>
<xsl:choose>
<xsl:when test="RevisionId">
<xsl:for-each select="/NewsML/NewsItem/Identification/NewsIdentifier">
<xsl:copy>
<xsl:copy-of select="@*"/>
<xsl:for-each select="/NewsML/NewsItem/Identification/NewsIdentifier/ProviderId">
<xsl:copy-of select="."/>
</xsl:for-each>
<xsl:for-each select="/NewsML/NewsItem/Identification/NewsIdentifier/DateId">
<xsl:copy-of select="."/>
</xsl:for-each>
<xsl:for-each select="/NewsML/NewsItem/Identification/NewsIdentifier/NewsItemId">
<xsl:copy-of select="."/>
</xsl:for-each>
<xsl:element name="RevisionId" namespace="">
<xsl:attribute name="PreviousRevision">
<xsl:value-of select="/NewsML/NewsItem/Identification/NewsIdentifier/RevisionId"/>
</xsl:attribute>
<xsl:attribute name="Update">N</xsl:attribute>
<xsl:value-of select="$RevNo"/>
</xsl:element>
<xsl:element name="PublicIdentifier" namespace="">
<xsl:value-of select="substring($root//PublicIdentifier,1,string-length($root//PublicIdentifier)-1)"/>
</xsl:element>
</xsl:copy>
</xsl:for-each>
</xsl:when>
<xsl:otherwise>
<xsl:variable name="upact">
<xsl:if test="@Duid">
<xsl:call-template name="uptype">
<xsl:with-param name="eleid" select="@Duid"/>
</xsl:call-template>
</xsl:if>
<xsl:if test="not(@Duid)"/>
</xsl:variable>
<xsl:variable name="upins">
<xsl:if test="$upact">
<xsl:call-template name="updata">
<xsl:with-param name="eleid" select="@Duid"/>
</xsl:call-template>
</xsl:if>
<xsl:if test="not($upact)"/>
</xsl:variable>
<xsl:choose>
<xsl:when test="$upact='Delete'"/>
<xsl:when test="$upact='Replace'">
<xsl:copy-of select="$upins"/>
</xsl:when>
</xsl:choose>
<xsl:if test="$upact!='Delete'">
<xsl:if test="$upact!='Replace'">
<xsl:if test="$upact='InsertBefore'">
<xsl:copy-of select="$upins"/>
</xsl:if>
<xsl:copy>
<xsl:apply-templates select="@*" mode="FCopy"/>
<xsl:apply-templates mode="FCopy">
<xsl:with-param name="RevNo" select="$locrev"/>
</xsl:apply-templates>
</xsl:copy>
<xsl:if test="$upact='InsertAfter'">
<xsl:copy-of select="$upins"/>
</xsl:if>
</xsl:if>
</xsl:if>
</xsl:otherwise>
</xsl:choose>
</xsl:template>


<xsl:template name="uptype">
<xsl:param name="eleid"/>
<xsl:for-each select="$root//Update">
<xsl:for-each select="*/@DuidRef">
<xsl:if test=".=$eleid">
<xsl:value-of select="name(parent::*)"/>
</xsl:if>
</xsl:for-each>
</xsl:for-each>
</xsl:template>


<xsl:template name="updata">
<xsl:param name="eleid"/>
<xsl:for-each select="$root//Update">
<xsl:for-each select="*/@DuidRef">
<xsl:if test=".=$eleid">
<xsl:for-each select="(parent::*)">
<xsl:apply-templates mode="copyins"/>
</xsl:for-each>
</xsl:if>
</xsl:for-each>
</xsl:for-each>
</xsl:template>


<xsl:template match="*|@*" mode="copyins">
<xsl:copy>
<xsl:apply-templates select="@*" mode="copyins"/>
<xsl:apply-templates mode="copyins"/>
</xsl:copy>
</xsl:template>


<xsl:template name="Catent">
<xsl:param name="NID"/>
<xsl:for-each select="document('../examples/NICatalog2.xml')/Catalog/Resource">
<xsl:if test="$NID=Urn">
<xsl:value-of select="Url"/>
</xsl:if>
</xsl:for-each>
</xsl:template>


</xsl:stylesheet>




















































































