<?xml version='1.0'?> 
<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl" 
                xmlns:fo="http://www.w3.org/TR/WD-xsl/FO" result-ns="fo"> 

<!-- Copyright (c) 1998 - 2001, NewsEdge Corp., MakeFeed 4.0 08-December-2000  --> 
<!-- File name: "story.xsl" --> 

<!-- Note: Stylesheets listed above are for displaying web pages in Microsoft -->
<!--       Internet Explorer Versions 5.0 and later. To use SAXON or other    -->
<!--       industry-standard XSL processors, a different URL is used.         --> 


<xsl:template match="/"> 
  <HTML> 
    <HEAD> 
      <TITLE><xsl:value-of select="/story/ne-nitf/nitf/body/body.head/hedline/hl1"/></TITLE> 
       NewsEdge Corporation's XML Review Topic Feed: Reviewed News for the 21st Century! <BR/><BR/> 
       <IMG align="bottom" alt="First for the Web" SRC="1stsmall.gif"/> <BR/> 

       <!-- Setup Styles to use Later --> 
       <STYLE> 
         <!-- General Body Text --> 
         BODY {font:8pt Verdana; width:50%; background-color: #FEFEF2; color:black; padding: 1em;} 
         PRE  {font:10pt Courier; color:black;} 

         <!-- Priority Headline Text --> 
         H1   {font:bold 18pt Verdana; color:red; width:100%; margin-top:1em} 
         H2   {font:bold italic 14pt Verdana; color:darkred; width:100%} 

         <!-- Normal Headline Text --> 
         H3   {font:bold 16pt Verdana; color:darkblue; width:100%; margin-top:1em} 
         H4   {font:bold italic 12pt Verdana; color:darkblue; width:100%} 

      </STYLE> 
    </HEAD> 

    <BODY> 
      <BR/> 
      Topic/Story Hierarchy Navigation. <B>(Click Topic Name to walk upward:)</B><BR/> 
      <BR/> 
      <!-- topic-ptr --> 
      <xsl:for-each select="/story/tsleaf"> 
        <xsl:value-of select="@indent"/> 
        <A> <xsl:attribute name="HREF"> 
              <xsl:value-of select="@file"/> 
            </xsl:attribute> 
            <xsl:value-of select="@display"/> 
        </A> 
        <xsl:if match=".[@type='topic']"> 
          &#160; (<xsl:value-of select="@numstories"/> stories) 
        </xsl:if> 
        <BR/>  
      </xsl:for-each> 

<BR/> 

      <!-- Base Headline and Lead on the Urgency --> 
      <xsl:choose> 
        <xsl:when test="/story/ne-nitf/nitf/head/docdata/urgency[@ed-urg $le$ '4']"> 
          <H1> 
            <p align="center"> 
              <xsl:value-of select="/story/ne-nitf/nitf/body/body.head/hedline/hl1"/> 
            </p> 
          </H1> 
          <H2> 
            <p align="center"><xsl:value-of select="/story/ne-nitf/nitf/body/body.head/abstract/p"/> 
            </p> 
          </H2> 
        </xsl:when> 
        <xsl:otherwise> 
          <H3> 
            <p align="center"><xsl:value-of select="/story/ne-nitf/nitf/body/body.head/hedline/hl1"/> 
            </p> 
          </H3> 
          <H4> 
          <p align="center"><xsl:value-of select="/story/ne-nitf/nitf/body/body.head/abstract/p"/> 
          </p> 
          </H4> 
        </xsl:otherwise> 
      </xsl:choose> 


      <!-- For Each Story Block Display It --> 
      <xsl:for-each select="/story/ne-nitf/nitf/body/body.content/block"> 
        <xsl:apply-templates /> 
      </xsl:for-each> 

      <!-- Use Hard Return line to seperate out NewsEdge Data --> 
      <HR STYLE="color:darkgreen"/> 


      <IMG align="bottom" alt="NewsEdge Corporation" SRC="indiv-s.gif"/> 
      <A> <xsl:attribute name="HREF"> 
            copyrite.html 
          </xsl:attribute> 
          NewsEdge Copyright 
      </A><BR/> 

    </BODY> 
  </HTML> 
</xsl:template> 



<!-- Default Templates: --> 

<!-- Display Text as is --> 
<xsl:template match="text()"> 
  <xsl:value-of /> 
</xsl:template> 

<!-- Apply Templates to all Tags --> 
<xsl:template match="*" > 
  <xsl:copy> 
    <xsl:apply-templates select="@* | node()" /> 
  </xsl:copy> 
</xsl:template> 

<!-- Apply Templates to all Subtags --> 
<xsl:template match="@*"> 
  <xsl:attribute> 
    <xsl:value-of /> 
  </xsl:attribute> 
</xsl:template> 



<!-- ############### Special Templates; Tags within Body Text ############### --> 

<!-- Quotes --> 
<xsl:template match="q"> 
  <FONT COLOR="blue">&#8220;<xsl:value-of select="."/>&#8221;</FONT> 
</xsl:template> 

</xsl:stylesheet>  
